//
//   File : kvi_about.cpp (/usr/build/NEW_kvirc/kvirc/src/kvirc/kvi_about.cpp)
//   Last major modification : Tue Dec 05 2000 06:00:00 by Christian Strmmen
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1999-2000 Till Bush (buti@geocities.com)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
#define __KVIRC_PLUGIN__
#include "kvirc_plugin.h"

#include "kvi_debug.h"

#define _KVI_ABOUT_CPP_

#include "kvi_locale.h"
#include "kvi_app.h"
#include "kvi_string.h"

#include "libkviabout.h"

#include <qscrollview.h>
#include <qpalette.h>
#include <qlayout.h>
#include <qtimer.h>
#include <qpushbutton.h>
#include <qbitmap.h>

#include <qsimplerichtext.h>

#include "kvi_opaquelabel.h"
//
//#include <qstylesheet.h>
//#include <qmime.h>

KviDlgAbout * g_pAboutDialog = 0;
void * g_about_plugin_handle = 0;
//KviWindow * g_pConsoleWindow = 0;

static char *g_szAboutText = "<center>\n" \
"<font color=\"#FFFFFF\" face=\"helvetica\" size=\"2\">\n" \
"<font color=\"#FF2020\"><h2>The KVIrc staff</h2></font><br>\n" \
"<br>\n" \
"<b>This is a small list<br>\n" \
"of people that have contributed<br>\n" \
"in some way to the KVIrc project</b><br>\n" \
"<font size=\"2\">(in a pseudo-random order at this point)</font><br>\n" \
"<br>\n" \
"<font size=\"3\"><b>\"Honor and Glory\" to\n:</b></font><br>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Szymon <font color=\"#FFA000\">'Pragma@OpenProjects\\IRCNet'</font> Stefanek</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[kvirc@tin.it]" \
	"</b></font><br>\n" \
		"The \"creator\" of KVirc<br>\n" \
		"Mental work, hand work,<br>\n" \
		"eyes consuming and coffee drinking<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"i'll check ... lemme check\"<br>\n" \
		"\"i'll fix it tomorrow\"<br>\n" \
		"\"KVIrc : the client that can't make coffee\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Christian <font color=\"#FFA000\">'Number1@Undernet\\OpenProjects'</font> Strmmen</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[number1@realityx.net]" \
	"</b></font><br>\n" \
		"Makes sure that nobody is lazy, bug-hunter, a LOT of suggestions and maker of RealityX IRC<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
                "\"Pragma: could you add these<br>\n" \
                "functions: $rubmyback() and<br>\n" \
                "$makecoffe() ?\"<br>\n" \
		"\"Skydyving is almost as exciting<br>\n" \
		"as KVIrc scripting !\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Krzysztof <font color=\"#FFA000\">'Kristoff@OpenProjects\\IRCNet'</font> Godlewski</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[kristoff@poczta.wprost.pl]" \
	"</b></font><br>\n" \
		"Official polish beer provider\n" \
		"and a heavily addicted developer.<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"echo \"STOP IT\" > /dev/neighbour\"<br>\n" \
		"\"cd ./neighbour && make clean\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Andrew <font color=\"#FFA000\">'Drosha@Undernet'</font> Frolov</b></font><br>\n" \
		"Beta testing<br>\n" \
		"Ideator of <u><font color=\"#9090FF\">www.kvirc.org</font></u><br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"This free project is better that shareware\n" \
		"mIrc for windows even in alpha stage\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>RAD Kade 1</b></font><br>\n" \
		"Debugging and improvements<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"I'm just *really* good at doing things\n" \
		"when I have no idea of what I'm actually doing\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Fritz <font color=\"#FFA000\">'KNFritz@IRCNet'</font> Elfert</b></font><br>\n" \
		"Improvements of KVIrc code<br>\n" \
		"and of my linux knowledge...<br>\n" \
		"I like to think of him as a 'spiritual guide'...<br>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Olle <font color=\"#FFA000\">'Crocodile@OpenProjects'</font> Hallnas</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[olle@xmms.org]" \
	"</b></font><br>\n" \
		"\"The open hand\" for the KVIrc project.<br>\n" \
		"Provider of the CVS service, www & ftp mirrors\n" \
		"great ideas and fun while coding<br>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>BuTi <font color=\"#FFA000\">'BuTi@IRCNet\\OpenProjects'</font></b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[buti@geocities.com]" \
	"</b></font><br>\n" \
		"Some \"tiny\" pieces of code...<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"but it _should_ work...\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Luk <font color=\"#FFA000\">'Balboy@IrcNet/OpenProjects'</font> De Ketelaere</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[balboy@skynet.be]" \
	"</b></font><br>\n" \
		"Help in documentation and bug-searching..<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"no idea what you're talking about... or why you need it :)\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Jan <font color=\"#FFA000\">'istari@IRCNet'</font> Wagner</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[istari@realityx.net]" \
	"</b></font><br>\n" \
		"Unbreakable supporter, bug-hunter and<br>\n" \
		"\"the man\" that gives you kvirc through IPV6.<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"&lt;istari&gt; im going in the kitchen cleaning dishes and cooking<br>\n" \
		"&lt;Mailer&gt; so istari is FAT<br>\n" \
		"&lt;istari&gt; eat my shorts :P<br>\n" \
		"Kristoff saw istari... he is as fat as a cow<br>\n" \
		"&lt;istari&gt; kristoff: ack :]<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Gian Fabio <font color=\"#FFA000\">'Mailer@IRCNet'</font> Palmerini</b></font><br>\n" \
		"Web master...<br>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Charles <font color=\"#FFA000\">'Njaard@OpenProjects'</font> Samuels</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[charles@altair.dhs.org]" \
	"</b></font><br>\n" \
		"The KDE man! Making sure that KVirc has a reason to have a K in the beginning<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"Could I please make KVirc a pure KDE application today?? Pleeease...\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Nick <font color=\"#FFA000\">'Error403@OpenProjects'</font> Betcher</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[nbetcher@real-time.com]" \
	"</b></font><br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"&lt;Error403&gt; Number1: I imagined you looking crazy :)\"<br>\n" \
		"\"&lt;NumeroUno&gt; I was drunk\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Andrea <font color=\"#FFA000\">'YaP@IRCNet\\OpenProjects'</font> Parrella</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[anandrea@iname.com]" \
	"</b></font><br>\n" \
		"Official bug hunter,<br>\n" \
		"plugin developer<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"why you haven't implemented a class like\n" \
		"DoEverythingByYourself ? :)\"<br>\n" \
		"\"&lt;Pragma&gt; a wonderful recursive function :)<br>\n" \
		"&lt;YaP&gt; Damn...I knew it eheheheheh\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>rn <font color=\"#FFA000\">'oehansen@Undernet'</font> E. Hansen</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[oe.hansen@gamma.telenordia.se]" \
	"</b></font><br>\n" \
		"The official C++ manual,\n" \
		"and plugin developer<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"prepare yourselves..<br>\n" \
		"#include &lt;iostream.h&gt;<br>\n" \
		"class testing {...\"<br>\n" \
		"\"&lt;oehansen&gt; I must admit, I'm getting confused :-)<br>\n" \
		"&lt;Pragma&gt; Me too , at this point :)\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Anodine <font color=\"#FFA000\">'[Anodine]@EFNet'</font></b></font><br>\n" \
		"Various funky improvements<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"I can program anything\n" \
		"I set my mind to!\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Ted <font color=\"#FFA000\">'alch3m1st@IRCNet'</font> Podgurski</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[tedp@toocool.com]" \
	"</b></font><br>\n" \
		"Test scripter, official bug hunter,<br>\n" \
		"ideator & creator of <u><font color=\"#9090FF\">www.kvirc.net</font></u><br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"whassup ?\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Christopher <font color=\"#FFA000\">'CGabriel@IRCNet'</font> R. Gabriel</b></font><br>\n" \
	"<font color=\"#4545FF\"><b>" \
		"[cgabriel@linux.it]" \
	"</b></font><br>\n" \
		"The 'light' inside the GNU clouds<br>\n" \
		"Generic (??!) official project supporter :)<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"Pragma: seems that kvirc with all its plugins is becoming a desktop environment\"<br>\n" \
		"\"echo espresso > /dev/coffee\"<br>\n" \
		"\"Pragma: you reached the user limit. WTF!\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Diabl0 <font color=\"#FFA000\">'Diabl0@IRCNet'</font></b></font><br>\n" \
		"Beta testing, bugs hunting<br>\n" \
		"also a great source for new ideas<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"Bus report...\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>Paul <font color=\"#FFA000\">'infected@IRCNet'</font> Boehm</b></font><br>\n" \
		"Beta testing ,<br>\n" \
		"language structure improvements<br>\n" \
	"<font color=\"#E0E0E0\"><i>\n" \
		"\"...it's enough for 100 IPs per meter\n" \
		"on earth, so every lightswitch can have\n" \
		"its own IP...then you telnet to your lightswitch\n" \
		"and turn it off!\"<br>\n" \
	"</i></font>\n" \
"<br>\n" \
"\n" \
	"<font color=\"#FFFF00\"><b>munehiro <font color=\"#FFA000\">'munehiro@IRCNet'</font></b></font><br>\n" \
		"Italian translations, code improvements and many useful suggestions<br>\n" \
"<br>\n" \
"<br>\n" \
"<br>\n" \
"<font color=\"#FFFF00\"><b>KVIrc public releases :</b></font><br>\n" \
"<br>\n" \
"<font color=\"#FF0000\">0.9.0</font><br>\n" \
"<font size=\"2\" color=\"#808080\">Release date: 25.01.1999</font><br>\n" \
"<br>\n" \
"<font color=\"#FF0000\">1.0.0 'Millennium'</font><br>\n" \
"<font size=\"2\">\"The net in your hands\"</font><br>\n" \
"<font size=\"2\" color=\"#808080\">Release date: 21.12.1999</font><br>\n" \
"<br>\n" \
"<font color=\"#FF0000\">2.0.0 'Phoenix'</font><br>\n" \
"<font size=\"2\">\"The client that can't make coffee\"</font><br>\n" \
"<font size=\"2\" color=\"#808080\">Release date: 30.05.2000</font><br>\n" \
"<br>\n" \
"<font color=\"#FF0000\">2.1.0 'Dark Star'</font><br>\n" \
"<font size=\"2\">\"The quiet before the storm\"</font><br>\n" \
"<font size=\"2\" color=\"#808080\">Release date: 30.01.2001</font><br>\n" \
"<br>\n" \
"<font color=\"#FF0000\">2.1.1 'Monolith'</font><br>\n" \
"<font size=\"2\">\"A breath of fresh net\"</font><br>\n" \
"<font size=\"2\" color=\"#808080\">Release date: 01.04.2001</font><br>\n" \
"\n" \
"</font>\n" \
"</center>";


KviDlgAbout::KviDlgAbout()
: QDialog(0) {
	
	setCaption(__tr("About KVirc"));

	QGridLayout *g = new QGridLayout(this,3,1,10,4);

	KviStr szImage;

	m_pfield = new KviOpaqueLabel(this);

	m_pfield->setFrameStyle(QFrame::Panel|QFrame::Sunken);
	g->addWidget(m_pfield,1,0);

	posy            = 0;

	m_pBackground = new QPixmap();
	if(g_pApp->findImage(szImage,"kvi_about_bg.png"))m_pBackground->load(szImage.ptr());
	else m_pBackground->resize(200,200);

	w=m_pBackground->width();
	h=m_pBackground->height();

	m_pfield->setFixedSize(w,h);

	QSimpleRichText doc(g_szAboutText,QFont("helvetica",16));
	doc.setWidth(w - 8);

	m_text_height=doc.height();

	// draw text and shadow
	m_ppix_text = new QPixmap(w,m_text_height);
	m_ppix_text->fill(Qt::black);
	QPainter p(m_ppix_text);

	QRegion reg(0,0,1000,20000);

	doc.draw(&p,0,0,reg,palette());
	m_ppix_text->setMask(m_ppix_text->createHeuristicMask(false));

	QPushButton * btn_ok = new QPushButton(__tr("Close"),this);
	btn_ok->setDefault(true);
	g->addWidget(btn_ok,2,0);
	connect(btn_ok,SIGNAL(clicked()),this,SLOT(close()));

	QTimer *timer = new QTimer(m_pfield);
	connect(timer,SIGNAL(timeout()),SLOT(scrollText()));
	timer->start(50);
}

void KviDlgAbout::scrollText() {
	posy++;
	repaint(false);
}


void KviDlgAbout::paintEvent( QPaintEvent * ) {

	QPixmap tmp_pix(*m_pBackground);
	QPainter p(&tmp_pix);
	bitBlt(&tmp_pix,4,((h - posy)+4),m_ppix_text,1,1,-1,-1);

	if( posy > h + m_text_height+4 ) {
		posy = 0;
	}
	p.end();
	bitBlt( m_pfield, 1, 1, &tmp_pix, 1, 1, w - 2, h - 2 );
}

KviDlgAbout::~KviDlgAbout()
{
	delete m_ppix_text;
	delete m_pBackground;
}

void about_plugin_dialog_closed(KviDlgAbout * dlg)
{
	delete dlg;
	g_pAboutDialog = 0;
	//kvirc_plugin_unregister_command(g_about_plugin_handle,"ABOUTKVIRC");
	// unload self
//	kvirc_plugin_execute_command(g_pConsoleWindow,"timer -s (kvirc_plugin_timer,0)plugin -q -m unload about");
}

void KviDlgAbout::closeEvent(QCloseEvent *)
{
	about_plugin_dialog_closed(this);
}

void KviDlgAbout::close()
{
	about_plugin_dialog_closed(this);
}

bool about_plugin_command_aboutkvirc(KviPluginCommandStruct *cmd)
{
 	if(!g_pAboutDialog){
		g_pAboutDialog = new KviDlgAbout();
		g_pAboutDialog->show();
	}
    return true;
}

// =======================================
// init routine
// =======================================
bool about_plugin_init(KviPluginCommandStruct *cmd)
{
	g_about_plugin_handle = cmd->handle;
//	g_pConsoleWindow = cmd->frame->m_pConsole;

    kvirc_plugin_register_command(cmd->handle,"ABOUTKVIRC",about_plugin_command_aboutkvirc);
    return true;
}

void about_plugin_cleanup()
{
	if(g_pAboutDialog)delete g_pAboutDialog;
	g_pAboutDialog = 0;
	kvirc_plugin_unregister_command(g_about_plugin_handle,"ABOUTKVIRC");
	kvirc_plugin_unregister_meta_object("KviDlgAbout");
}

// =======================================
// plugin definition structure
// =======================================
KviPlugin kvirc_plugin =
{
    "About" ,
    "The KVIrc 'Hall of fame'" ,
    "1.0" ,
    "Till Bush <buti@geocities.com>\n" \
	"Szymon Stefanek <stefanek@tin.it>" ,
	"Exports the /aboutkvirc command.",
    about_plugin_init ,
    about_plugin_cleanup ,
    0,
    0
};

#include "libkviabout.moc"
